
set(SCOREC_VERSION 3.0.2)
include(CMakeFindDependencyMacro)
# we will use find_dependency, but we don't want to force
# our users to have to specify where all of our dependencies
# were installed; that defeats the whole point of automatically
# importing dependencies.
# since the documentation for find_dependency() doesn't mention
# a PATHS argument, we'll temporarily add the prefixes to
# CMAKE_PREFIX_PATH.
set(SCOREC_DEPS "")
set(SCOREC_DEP_PREFIXES "")
set(SCOREC_BACKUP_PREFIX_PATH "${CMAKE_PREFIX_PATH}")
set(CMAKE_PREFIX_PATH "${SCOREC_DEP_PREFIXES};${CMAKE_PREFIX_PATH}")
foreach(dep IN LISTS SCOREC_DEPS)
  find_dependency(${dep})
endforeach()
set(CMAKE_PREFIX_PATH "${SCOREC_BACKUP_PREFIX_PATH}")
set(SCOREC_EXPORTED_TARGETS "lion;pcu;gmi;can;mth;apf;mds;parma;apf_zoltan;pumi;ma;crv;spr;ree;sam;ph;core;verify;describe;mkmodel;mktopomodel;modelInfo;uniform;classifyThenAdapt;refine2x;serialize;tetrahedronize;intrude;extrude;from_gmsh;from_ansys;from_neper;from_ugrid;nektar_align;icesheet;matchedNodeElmReader;render;renderClass;render_ascii;measureAnisoStats;measureIsoStats;visualizeAnisoSizes;split;zsplit;collapse;repartition;balance;reorder;fixshape;fixlayer;fixDisconnected;scale;chef;condense;threshold;chefReadUrPrep;chefStream;adaptLvlSetLoop;print_pumipic_partition")
foreach(tgt IN LISTS SCOREC_EXPORTED_TARGETS)
  include(${CMAKE_CURRENT_LIST_DIR}/${tgt}-target.cmake)
endforeach()
foreach(_comp ${SCOREC_FIND_COMPONENTS})
  if (NOT ";${SCOREC_EXPORTED_TARGETS};" MATCHES ${_comp})
    set(SCOREC_${_comp}_FOUND False)
    if ( SCOREC_FIND_REQUIRED_${_comp} )
      MESSAGE(SEND_ERROR "Required SCOREC component not found: ${_comp}")
    endif()
  else()
    set(SCOREC_${_comp}_FOUND True)
  endif()
  MESSAGE(STATUS "SCOREC component ${_comp} found: ${SCOREC_${_comp}_FOUND}")
endforeach()
set(SCOREC_COMPILER "/usr/bin/c++")
set(SCOREC_CXX_FLAGS " -g ")
